/*
   This is the reference solution to problem A ('Gra planszowa')

   Author : Bartosz Nowierski
*/
#include <stdio.h>
#include <assert.h>
#include <string.h>


#define MAXN 100
#define MAXG 10


char board[1000];
int gen[MAXN+1];
int size, size0, count;


int main()
{
  int B, b;
  int G, g;
  int N, i;
  int f1, f2;
  char ch;
  int chcnt;
  int res;


  scanf("%d", &B);
  for (b = 0; b < B; ++b)
  {
    printf("PLANSZA %d\n", b+1);

    scanf("%s", board);
    size0 = size = strlen(board);
assert((size0 >= 1) && (size0 <= 255));
    scanf("%d", &N);
assert((N >= 1) && (N <= MAXN));
    gen[0] = size0;
    count = 1;
    for (i = 0; i < N; ++i)
    {
      scanf("%d", &gen[i+1]);
assert(gen[i+1] >= 1);
      count *= gen[i+1];
      size *= gen[i+1];
assert((size > 0) && (size <= 2100000000));
    }

    scanf("%d", &G);
assert((G >= 1) && (G <= MAXG));
    for (g = 0; g < G; ++g)
    {
      printf("GRA %d: ", g+1);

      scanf("%d%d", &f1, &f2);
assert((f1 >= 1) && (f1 <= size) && (f2 >= 0) && (f2 <= size) && (f1 != f2));
      --f1;
      --f2;
      if (f1 > f2)
      {
        f1 ^= f2;
        f2 ^= f1;
        f1 ^= f2;
      }
      ch = board[f1%size0];
assert(ch == board[f2%size0]);
      chcnt = 0;
      for (i = 0; i < size0; ++i)
      {
        if (board[i] == ch)
        {
          ++chcnt;
        }
      }
      res = ((f2/size0)-(f1/size0))*chcnt;
      f1 %= size0;
      f2 %= size0;
      if (f1 <= f2)
      {
        for (i = f1; i < f2; ++i)
        {
          if (board[i] == ch)
          {
            ++res;
          }
        }
      }
      else
      {
        for (i = f2; i < f1; ++i)
        {
          if (board[i] == ch)
          {
            --res;
          }
        }
      }
      
      printf((res%2 == 1) ? "TAK\n" : "NIE\n");
    }
    printf("\n");
  }

  return 0;
}
