/*
   This is the reference solution to problem B ('Fabryki')

   Author : Bartosz Nowierski
*/
#include <stdio.h>

int map[100010];
int obj[100];
int city[100];
int N, F, C;
int G[100][100];

int D[100];


void dijkstra(int s)
{
  int i, k;
  int min;
  int minno;
  int u[100];
  
  for (i = 0; i < C+F; ++i)
  {
    D[i] = 1000000000;
    u[i] = 0;
  }
  D[s] = 0;
  for (k = 0; k < C+F; ++k)
  {
    min = 1000000000;
    for (i = 0; i < C+F; ++i)
    {
      if (!u[i] && D[i] < min)
      {
        min = D[i];
        minno = i;
      }
    }
    u[minno] = 1;
    for (i = 0; i < C+F; ++i)
    {
      if (D[minno]+G[i][minno] < D[i])
      {
        D[i] = D[minno]+G[i][minno];
      }
    }
  }
}


int main()
{
  int i, j;
  int d;
  int M;
  int total;
  int min;


  scanf("%d", &d);
  while (d--)
  {
    scanf("%d", &F);
    for (i = 0; i < F; ++i)
    {
      int num;
      int req;
      scanf("%d%d", &num, &req);
      map[num] = i;
      obj[i] = req;
    }
    scanf("%d", &C);
    for (i = 0; i < C; ++i)
    {
      int num;
      int cost;
      scanf("%d%d", &num, &cost);
      map[num] = i+F;
      obj[i+F] = cost;
    }
    scanf("%d", &M);
    for (i = 0; i < C+F; ++i)
    {
      for (j = 0; j < C+F; ++j)
      {
        G[i][j] = 1000000000;
      }
    }
    for (i = 0; i < M; ++i)
    {
      int v1, v2, c;
      scanf("%d%d%d", &v1, &v2, &c);
      
      G[map[v1]][map[v2]] = c;
      G[map[v2]][map[v1]] = c;
    }
/*
    for (i = 0; i < C+F; ++i)
    {
      for (j = 0; j < C+F; ++j)
      {
        printf("%d ", G[i][j]);
      }
      printf("\n");
    }
  */  
    total = 0;
    for (i = 0; i < F; ++i)
    {
      dijkstra(i);
      min = 2100000000;
      for (j = F; j < C+F; ++j)
      {
        if (D[j]+obj[j] < min)
        {
          min = D[j]+obj[j];
        }
      }
      total += min*obj[i];
    }

    printf("%d\n", total);
  }

  return 0;
}
