/*
   This is the reference solution to problem D ('ukladanie kart')

   Author : Bartosz Nowierski
*/

#include <stdio.h>
#include <assert.h>

#define MAX 1000

int T[MAX];
int D[MAX];
int N;


int main()
{
  int U[MAX];
  int d;
  int i, j;
  int max;


  assert(scanf("%d", &d) == 1);
  while (d--)
  {
    assert(scanf("%d", &N) == 1);
    assert((N >= 1) && (N <= MAX));
    for (i = 0; i < N; ++i)
    {
      U[i] = 0;
    }
    for (i = 0; i < N; ++i)
    {
      assert(scanf("%d", &T[i]) == 1);
      assert((T[i] >= 1) && (T[i] <= N));
      --T[i];
      U[T[i]] = 1;
    }
    for (i = 0; i < N; ++i)
    {
      assert(U[i]);
    }

    D[0] = 1;
    for (i = 1; i < N; ++i)
    {
      max = 0;
      for (j = 0; j < i; ++j)
      {
        if ((T[j] < T[i]) && (D[j] > max))
        {
          max = D[j];
        }
      }
      D[i] = max+1;
    }
    max = 0;
    for (i = 0; i < N; ++i)
    {
      if (D[i] > max)
      {
        max = D[i];
      }
    }
    printf("%d\n", N-max);
  }

  return 0;
}
