/*
   This is the reference solution to problem E ('transformacje')

   Author : Bartosz Nowierski
*/

#include <stdio.h>
#include <assert.h>

#define MAX 50000
int T[MAX];
int N, K;



int main()
{
  int d;
  int i;
  int ok;


  assert(scanf("%d", &d) == 1);
  assert(d > 0);
  while (d--)
  {
    assert(scanf("%d", &N) == 1);
    assert((N >= 2) && (N <= MAX));
    for (i = 0; i < N; ++i)
    {
      assert(scanf("%d", &T[i]) == 1);
      assert((T[i] == 0) || (T[i] == 1));
    }
    K = N;
    while ((K&1) == 0)
    {
      K >>= 1;
    }
    K = N/K;

    ok = 1;
    for (i = 0; i < N; ++i)
    {
      if (T[i] != T[(i-K+N)%N])
      {
        ok = 0;
        break;
      }
    }

    printf(ok?"TAK\n":"NIE\n");
  }
  
  return 0;
}
